ru.yandex.clickhouse.jdbc.parser

## Interface CharStream

All Known Implementing Classes:
  AbstractCharStream, SimpleCharStream

    public interface CharStream

This interface describes a character stream that maintains line and column number positions of the characters. It also has the capability to backup the stream to some extent. An implementation of this interface is used in the TokenManager implementation generated by JavaCCParser. All the methods except backup can be implemented in any fashion. backup needs to be implemented correctly for the correct operation of the lexer. Rest of the methods are all used to get information like line number, column number and the String that constitutes a token and are not used by the lexer. Hence their implementation won't affect the generated lexer's operation.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `backup(int amount)` Backs up the input stream by amount steps.
`char` `beginToken()`
`void` `done()` The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class.
`int` `getBeginColumn()`
`int` `getBeginLine()`
`int` `getEndColumn()`
`int` `getEndLine()`
`String` `getImage()`
`char[]` `getSuffix(int len)`
`int` `getTabSize()`
`boolean` `isTrackLineColumn()`
`char` `readChar()` Get the next character from the selected input.
`void` `setTabSize(int i)` Set the tab size to use.
`void` `setTrackLineColumn(boolean trackLineColumn)` Enable or disable line number and column number tracking.

### Method Detail

#### readChar

    char readChar()
           throws IOException

Get the next character from the selected input. The method of selecting the input is the responsibility of the class implementing this interface.

Returns:
  the next character from the selected input
Throws:
  `IOException` - on IO error

#### getBeginColumn

    int getBeginColumn()

Returns:
  the column number of the first character for current token (being matched after the last call to beginToken).

#### getBeginLine

    int getBeginLine()

Returns:
  the line number of the first character for current token (being matched after the last call to BeginToken).

#### getEndColumn

    int getEndColumn()

Returns:
  the column number of the last character for current token (being matched after the last call to BeginToken).

#### getEndLine

    int getEndLine()

Returns:
  the line number of the last character for current token (being matched after the last call to BeginToken).

#### backup

    void backup(int amount)

Backs up the input stream by amount steps. Lexer calls this method if it had already read some characters, but could not use them to match a (longer) token. So, they will be used again as the prefix of the next token and it is the implemetation's responsibility to do this right.

Parameters:
  `amount` - Number of chars to back up.

#### beginToken

    char beginToken()
             throws IOException

Returns:
  the next character that marks the beginning of the next token. All characters must remain in the buffer between two successive calls to this method to implement backup correctly.
Throws:
  `IOException`

#### getImage

    String getImage()

Returns:
  a string made up of characters from the marked token beginning to the current buffer position. Implementations have the choice of returning anything that they want to. For example, for efficiency, one might decide to just return null, which is a valid implementation.

#### getSuffix

    char[] getSuffix(int len)

Returns:
  an array of characters that make up the suffix of length 'len' for the currently matched token. This is used to build up the matched string for use in actions in the case of MORE. A simple and inefficient implementation of this is as follows:

         {
            String t = getImage();
            return t.substring(t.length() - len, t.length()).toCharArray();
         }

#### done

    void done()

The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class. Again, the body of this function can be just empty and it will not affect the lexer's operation.

#### getTabSize

    int getTabSize()

Returns:
  Current tab size.

#### setTabSize

    void setTabSize(int i)

Set the tab size to use.

Parameters:
  `i` - spaces per tab

#### isTrackLineColumn

    boolean isTrackLineColumn()

Returns:
  `true` if line number and column numbers should be tracked.

#### setTrackLineColumn

    void setTrackLineColumn(boolean trackLineColumn)

Enable or disable line number and column number tracking.

Parameters:
  `trackLineColumn` - `true` to track it, `false` to not do it.